#ifndef CoCoA_RingDenseUPolyClean_H
#define CoCoA_RingDenseUPolyClean_H

//   Copyright (c)  2007  Anna Bigatti

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License (version 2)
//   as published by the Free Software Foundation.  A copy of the full
//   licence may be found in the file COPYING in this directory.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoA; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


namespace CoCoA
{

  class symbol;         // forward declaration -- defined in symbol.H
  class ring;           // forward declaration -- defined in ring.H
  class DenseUPolyRing;  // forward declaration -- defined in DensePolyRing.H

  // Pseudo-ctors for (sparse) polynomial rings.

  DenseUPolyRing NewPolyRing_DUP(const ring& CoeffRing); ///< default indet name is x
  DenseUPolyRing NewPolyRing_DUP(const ring& CoeffRing, const symbol& IndetName);

} // end of namespace CoCoA

// RCS header/log in the next few lines
// $Header: /Volumes/Home/cocoa/cvs-repository/CoCoALib-0.99/include/CoCoA/RingDenseUPolyClean.H,v 1.1 2007/10/05 15:28:56 bigatti Exp $
// $Log: RingDenseUPolyClean.H,v $
// Revision 1.1  2007/10/05 15:28:56  bigatti
// -- added abstract class DenseUPolyRing for representing dense
//    univariate polynomials
// -- added concrete class RingDenseUPolyClean, the cleanest
//    implementation
// -- just for testing, still horribly inefficient and incomplete
//

#endif
